

plot.Dendro <- function(cl,cluster) {
  k <- length(unique(cluster$cluster_rank))
  dhc <- as.dendrogram(cl)
  ddata <- dendro_data(cl, type = "rectangle")

  labs <- ddata$labels %>%
    left_join(cluster %>%
                mutate(label = paste(label, id, sep = "|")) %>%
                select(label, cluster_rank)) %>%
    separate(label, c("label", NA), sep = "\\|") %>%
    mutate(label=paste(cluster_rank,label))

  p <- ggplot(segment(ddata)) +
    geom_segment(aes(
      x = x,
      y = y,
      xend = xend,
      yend = yend
    ),
    size = 0.2) +
    geom_text(
      data = labs,
      aes(
        x = x,
        y = y,
        label = label,
        color = as.factor(cluster_rank)
      ),
      size = 1,
      hjust = 0,
      vjust = 0.5
    ) +
    coord_flip() +
    scale_y_reverse(expand = c(0.2, 0)) +
    scale_color_manual(values = kelly(k),name="Cluster") +
    theme_dendro()

  return(p)

}